import cv2
import numpy as np
import pandas as pd
import glob
imgdir = 'images/*.jpg'
scaleLongAxis = 4.59052759225501e-4
scaleShortAxis = 4.864019947204133e-4
dataframes = []
for img in glob.glob(imgdir):
    filename =img.split('\\')[1]
    print(filename)
    cv_img = cv2.imread(img)
    #convert img to grey
    img_grey = cv2.cvtColor(cv_img,cv2.COLOR_BGR2GRAY)
    #set a thresh
    thresh = 10
    #get threshold image
    ret,thresh_img = cv2.threshold(img_grey, thresh, 255, cv2.THRESH_BINARY)
    #find contours
    contours, hierarchy = cv2.findContours(thresh_img, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
    cnt = np.vstack(contours).squeeze()
    ellipse = cv2.fitEllipse(cnt)
    (xc, yc), (width, height), angle = ellipse

    # cv2.ellipse(cv_img,ellipse,(0,255,0),2)

    dataframe = []

    long_axis = height * scaleLongAxis
    long_axis = '{:.3f}'.format(long_axis)
    short_axis = width * scaleShortAxis
    short_axis = '{:.3f}'.format(short_axis)

    dataframe.append(filename)
    dataframe.append(short_axis)
    dataframe.append(long_axis)
    dataframes.append(dataframe)
    # dataframes.apppend(dataframe)
df = pd.DataFrame(dataframes, columns=['filename', 'short distance (mm)', 'long distance (mm)'])

# print(dataframes)
df.to_csv('result.csv', index = False)

#print(long_axis, short_axis)